package oop1_dat1_u;

//import java.util.ArrayList;
//import java.util.Iterator;

/**
 *
 * @author Felix Rohrer <felix.rohrer@stud.hslu.ch>
 */
public class Bank
{

    private String name;
    //private ArrayList<Konto> kontoList;
    private MyLinkedList<Konto> kontoList;

    public Bank()
    {
        this("Bank");
    }

    public Bank(String newName)
    {
        name = newName;
        //kontoList = new ArrayList<Konto>();
        kontoList = new MyLinkedList<Konto>();
        System.out.println("Bank: '" + newName + "' wurde erstellt.");
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args)
    {
        /*
         Konto myKonto = new Konto();
        myKonto.print();
        myKonto.payIn(100.0);
        myKonto.print();
        myKonto.payOut(50.0);
        myKonto.print();

        Konto myKonto2 = new Konto(10000.0, 5.5);
        myKonto2.print();
        myKonto2.payOut(1234.5);
        myKonto2.print();

        Spar mySpar = new Spar(1000.0, 7.5, 200.0);
        mySpar.print();
        mySpar.payOut(200.0);
        mySpar.print();
         */

        Bank myBank = new Bank("Meine Bank");
        myBank.openKonto();
        myBank.openKonto(20000.0, 2.5);
        myBank.openKontoRnd();
        myBank.openKontoRnd();
        myBank.openKontoRnd();
        myBank.openSpar();
        myBank.openSpar(100000.0, 5.0, 1000.0);
        myBank.openSparRnd();

        System.out.println("Anzahl Konto: " + myBank.noOfAccounts());
        myBank.printAccounts();
        myBank.printFund();
    }

    public void openKonto()
    {
        //kontoList.add(new Konto());
        kontoList.insert(new Konto());
    }

    public void openKontoRnd()
    {
        openKonto(Math.random()*1000, Math.random()*2);
    }

    public void openKonto(double newSaldo, double newRate)
    {
        kontoList.insert(new Konto(newSaldo, newRate));
    }

    public void openSpar()
    {
        kontoList.insert(new Spar());
    }
    public void openSparRnd()
    {
        openSpar(Math.random()*5000, Math.random()*5, Math.random()*1000);
    }

    public void openSpar(double newSaldo, double newRate, double newMaxOut)
    {
        kontoList.insert(new Spar(newSaldo, newRate, newMaxOut));
    }

    public int noOfAccounts()
    {
        return kontoList.size();
    }

    public void printAccounts()
    {
        /*
        Iterator<Konto> itr;
        itr = kontoList.iterator();
        while (itr.hasNext()) {
            itr.next().print();
        }
         */
        MyListNode actualNode = kontoList.getHead();
        System.out.println("----------");
        while (actualNode != null) {
            Konto k = (Konto)actualNode.getData();
            k.print();
            actualNode = actualNode.getNext();
        }
    }

    public void printFund()
    {
        /*
         int sumFund = 0;
        Iterator<Konto> itr;
        itr = kontoList.iterator();
        while (itr.hasNext()) {
            sumFund += itr.next().getSaldo();
        }
        System.out.println("Summe aller Flüssige Mittel: " + sumFund);
        */
        MyListNode actualNode = kontoList.getHead();
        double sumFund = 0.0;
        while (actualNode != null) {
            Konto k = (Konto)actualNode.getData();
            sumFund += k.getSaldo();
            actualNode = actualNode.getNext();
        }
        //System.out.println("Summe aller flüssigen Mittel: " + sumFund);
        System.out.format("Summe aller flüssigen Mittel: %.2f%n", sumFund);
    }
}
